

//	 Un semplice gioco di prova per imparare ad utilizzare Bennu
// 	 Zilli Roberto
//   www.openconsole.it



import "mod_grproc"
import "mod_screen"
import "mod_text"
import "mod_time"
import "mod_rand"
import "mod_video"
import "mod_map"
import "mod_math"
import "mod_scroll"
import "mod_sound"


#include "jkeys.lib"



global

int velocita_nave = 8; // 8
int ship_id;
int lives;
int lv1;
int common;
int EndGame=0;
int score=0;
string text[3];

//// parte 2
int res = 10;
int respawn;
int tempo_respawn=4000; // tempo di respawn
int tempo_sparo = 210;
int lastShoot  = 210;
int velocita_sparo_normale = 85;
int Shoot_power= 2;

int nonsparare = 400;
numerospari=0;
//// parte 2

process Main ( )
	
	
	begin
	jkeys_set_default_keys();
	jkeys_controller();
	
	define_region ( 1 , 0 , 0 , 320 , 240  );
	
	common=load_fpg ("common.fpg");
	
	lv1=load_fpg ("lv1fpg.fpg");
	
	set_mode ( 320 , 240 , 16 );
	
	set_fps ( 60 , 2 );
	
	
	loop  	// fa partire va in loop controllando quando 
			//	viene messo in pausa e aggiorna armi vite e punti.
		lives=5; // vite
		score=0;
		EndGame=0;
	
		Game ();
		
		repeat
	   
			if(lives>=0)
				set_text_color(rgb(200,208,240));
				text[0]=write(0,120,5,3,"LIVES "+lives);
				text[1]=write(0,5,5,3,"SCORE "+score);
				set_text_color(rgb(255,255,255));
				frame;  
		
			else //lives < 0
			
				
				signal(type Ship,s_kill);
				
				EndGame=1;

				signal(type Fondale,s_kill);
				
				break;//repeat
				
			end //if vite
		 	 


		until (EndGame==1)  // menu prima era select

			let_me_alone();
			jkeys_controller();
			stop_scroll(0); //  pianeta
			stop_scroll(1); //  stelle
			
		
		  delete_text(all_text);
		  frame;

	end 
end






process Fondale () 
	private
	
	int cont=0;

	begin

 
	file=lv1;
		
		start_scroll (1,lv1,12,0,1,1);//  stelle
		start_scroll (2,lv1,13,0,1,1);//  stelle

	loop
			for ( cont = 1 ; cont< 3 ; cont = cont+ 1 )
				frame;
			end
		scroll[1].x0 = scroll[1].x0 + 1; //  stelle
		scroll[2].x0 = scroll[2].x0 + 2; //  stelle
    end	 
end






process Game ( )
begin
	Fondale(); 
	ship_id = Ship ( );
	// parte 2
	Level();
	// parte 2
	loop 
		frame; 
	end
end

	 
	 
	 
	 
process Ship ( );
	private
     int xm;
     int ym;
	begin

     resolution=10;
     file=common;
     region = 1;

	 graph = 10;
	 
     x = 400;
     y = 1200;
	loop
	
	
	
	//parte 2
	// SPARO 
	if((jkeys_state[_JKEY_A])) // sparo 
		if(get_timer()-lastShoot>tempo_sparo)
			Shoot();
			lastShoot=get_timer();
		end
	elseif(!(jkeys_state[_JKEY_A])) 
		lastShoot=-tempo_sparo;
	else 
	end  
	//parte 2
	
	
	  
	  if ( (jkeys_state[_JKEY_RIGHT]) || (jkeys_state[_JKEY_LEFT]) )

     	  if ( jkeys_state[_JKEY_RIGHT] )
     	       if ( ! jkeys_state[_JKEY_LEFT] )
   	  	            xm = xm + velocita_nave;								
   	  	       	end
             end

     	  if ( jkeys_state[_JKEY_LEFT] )
     	       if ( ! jkeys_state[_JKEY_RIGHT] )
     	            xm = xm - velocita_nave;			
     	         end
     	      end
			   
	 			
			
			
          if ( xm > 20 )
          	   xm = 20;
          end

          if ( xm < -20 )
          	   xm = -20;
          end

          else

		if ( xm > 0 )
		     xm = xm - 2;
	             end

		if ( xm < 0 )
		     xm = xm + 2;
	             end

	      end
	  
		  
	 if ( (jkeys_state[_JKEY_UP]) || (jkeys_state[_JKEY_DOWN]) )

     	  if (( jkeys_state[_JKEY_UP] ) && ( ! jkeys_state[_JKEY_DOWN] ))
   	  	            ym = ym - velocita_nave;
															
          end
			   
     	  if (( jkeys_state[_JKEY_DOWN] ) &&( ! jkeys_state[_JKEY_UP] ))
     	            ym = ym + velocita_nave;
				
     	  end
          If ( ym > 20 )
          	   ym = 20;
          	   End
          If ( ym < -20 )
          	   ym = -20;
          	   End
          else

		  If ( ym > 0 )
		       ym = ym - 2;
			   End

		  If ( ym < 0 )
		       ym = ym + 2;
			   End

	      end

		  If ( y > 2280 )
		       y = 2280;
	           End

		  If ( y < 140 )
		       y = 140;
		       End

		  If ( x > 3000 )
		       x = 3000;
	           End

		  If ( x < 200 )
		       x = 200;
		       End

          x = x + xm;
          y = y + ym;

     frame;

     end
end



//parte 2 /// fatto
process Shoot (); // sparo base--------------------------------------
begin

	 resolution=res;
	 file=common;
	 region=1;
	 graph=6;
	 
	 x=ship_id.x+170;
	 y=ship_id.y-10;
	 
	 fiamma_sparo_normale(x,y);
	 repeat
		x+=velocita_sparo_normale;
		frame;
	 until(out_region(id,region));
	 signal(id,s_kill);
end

//parte 2


//parte 2//// fatto

process fiamma_sparo_normale (int a, int b ); // fiamma sparo normale--------------------------------------

	begin
	resolution=res;
	file=common;
	region=1;
	graph=rand(99,101);
	x=a+58;
	y=b;
	frame(200);
	signal(id,s_kill);
end

//parte 2

	
//parte 2
process Explode ( );  // ------------------------esplosione nave----------------------------------------
	begin

	resolution=res;
	file=common;
	region=1;
	graph=933;
	x=ship_id.x;
	y=ship_id.y;
	 
	signal(ship_id,s_sleep);

	tempo_respawn=get_timer();
	 frame(210);
	 repeat
	 graph+=1;
	 frame(210);
	 until(graph==962)
	lives-=1;
	 frame(3000);
	 signal(ship_id,s_wakeup);
	 ship_id.x=400;
	 ship_id.y=1200;
	 end
	
	
	
	
		
		 
process Death ( );  //fine nemico esplosione piccola 35 x 35 -------------------------------------------------------------
begin

	 resolution=res;
	 file=common;
	 region=1;
	 graph=450;
	 
	 x=father.x;
	 y=father.y;
	 
	 signal(father,s_sleep);
	 repeat
	 graph+=1;
	 frame(200);
	 until(graph>458)
	 father.x=-10000;
	 signal(father,s_kill);
	 frame;
	 signal(id,s_kill);
	 end
	
//parte 2




	
	
	//parte 2
process Level()
	
begin

		
frame(2000);
	text[2]=write(0,160,110,4,"MISSION 1");
	frame(7000);
	delete_text(text[2]);
	text[2]=write(0,160,140,4,"START !");
	frame(3000);
	delete_text(text[2]);
	frame(1000);
	text[2]=write(0,160,140,4,"START !");
	frame(3000);
	delete_text(text[2]);
		
		
		
		frame(5000);
		Nemico(3250,1200,0);
		frame(7000);
		Nemico(3250,800,0);
		frame(7000);
		Nemico(3250,1700,0);
		frame(5000);
	end

//parte 2


/// fatto
process Nemico( int xpos, int ypos, int numero, ); // nemico 1 -----------------------------------
			
	private
		
	int timeShot=0;
		
	int ang=180000;
	int energia;
	
	int timeanim;
	int animazione=50; //enemy 0
		
	begin

	
		// energia nemici 
		if (numero == 0) 
			energia = 5;	
			else energia = 2;
		end
		
		timeShot=get_timer();
		resolution=res;
		flags=0;
		region=1;
		x=xpos;
		y=ypos;
file=lv1; 
	
	 loop 
	 
		if(collision(ship_id)) // collisione nave----------------------------------------
			if(get_timer()-respawn>tempo_respawn)
					Explode();
			Death();
			end
		end
		
		if(collision(type Shoot))// collisione sparo 1 ----------------------------
			energia -= Shoot_power;
	    end
		
		if (energia <= 0)
			score+=5;
			Death();
		end
		 
		
		
		
		
		
		
		//sfera si muove in orizzontale a sinistra
		if(numero==0)
			if (get_timer()-timeanim>80)
				graph=animazione;
				animazione+=1;
				if (animazione>56)
					animazione=50;
				end
				timeanim=get_timer();
			end		
			if (x>2800)
				xadvance(180000,9);
			end			
			if ((x<=2800)& (x>=1900))
				xadvance(200000,11);
			end
			
			if (x<1900)
				xadvance(180000,9);
			end			
			if ((get_timer()-timeShot>1500)& (x > nonsparare)& (numerospari < 2))
				sparo_nemico(548, 549, 12);
				timeShot=get_timer();
			end
		end // numero 0
		
		
		if(out_region(id,region))
		 signal(id,s_kill);
		end
		
		frame;
	end //loop
end




process sparo_nemico(int gr, int gr2, int sp)
private
int timeanim = 0;
int animazione;

begin
numerospari+=1;
animazione = gr;
	 resolution=res;
	  file=lv1;
	 graph=gr;
	 region=1;
	 x=father.x;
	 y=father.y;
	 angle=fget_angle(ship_id.x,ship_id.y,father.x,father.y);

	 repeat
	 
	 /////////////////////
	 if (get_timer()-timeanim>100)
		graph=animazione;
		animazione+=1;
			if (animazione>gr2)
			animazione=gr;
			end
			timeanim=get_timer();
		end
	 ///////////////////////////////
	 advance(-sp);
	 
	 
		if(collision(ship_id))
		if(get_timer()-tempo_respawn>respawn)
		 Explode();
		  x=10000;
		end
		end
	 frame;
	 until(out_region(id,region))   ;
	 numerospari-=1;
	 signal(id,s_kill);
	 
	 //respawnTime=get_timer();
end
	 
